/// <reference types="socket.io-client" />
import { ServerData, ActionData, ServerInfoData, EntitiesData, NewMapData } from "./definitions/adventureland-server";
import { ServerRegion, ServerIdentifier } from "./definitions/adventureland";
import { GData2, MapName, MonsterName } from "./definitions/adventureland-data";
import { Entity } from "./Entity";
import { Player } from "./Player";
export declare class Observer {
    socket: SocketIOClient.Socket;
    protected lastPositionUpdate: number;
    G: GData2;
    entities: Map<string, Entity>;
    protected pingMap: Map<string, {
        log: boolean;
        time: number;
    }>;
    protected pingNum: number;
    pings: number[];
    players: Map<string, Player>;
    projectiles: Map<string, ActionData & {
        date: Date;
    }>;
    S: ServerInfoData;
    serverRegion: ServerRegion;
    serverIdentifier: ServerIdentifier;
    map: MapName;
    x: number;
    y: number;
    constructor(serverData: ServerData, g: GData2, reconnect?: boolean);
    connect(): Promise<void>;
    protected parseEntities(data: EntitiesData): Promise<void>;
    protected parseNewMap(data: NewMapData): void;
    protected updatePositions(): void;
    sendPing(log?: boolean): string;
    getNearestMonster(mtype?: MonsterName): {
        monster: Entity;
        distance: number;
    };
}
